$(function() {
  var url = window.location.href;
  var ajaxJson = {
    'current_url': url
  };
  if (_authcache_is_numeric(Drupal.settings.easy_authcache.max_age)) {
    ajaxJson['max_age'] = Drupal.settings.easy_authcache.max_age;
  }
  var option = {};
  for (var v in Drupal.settings.easy_authcache.items) {
    var key = Drupal.settings.easy_authcache.items[v]['id'];
    var value = '';
    value = Drupal.settings.easy_authcache.items[v]['data'];
    if (!option[key]) {
      option[key] = {};
    }
    option[key][v] = value;
  }
  
  if (Drupal.settings.easy_authcache.single_request == true) {
      var send = [];
      send['easy_authcache'] = JSON.stringify(option);
      ajaxJson = $.extend(ajaxJson, send);
      if (typeof(Authcache) != 'undefined') Authcache.ajaxRequest(ajaxJson);
  }
  else {
    for(var key in option) {
      var send = [];
      var temp = {};
      temp[key] = option[key];
      send['easy_authcache'] = JSON.stringify(temp);
      ajaxJson = $.extend(ajaxJson, send);
      if (typeof(Authcache) != 'undefined') Authcache.ajaxRequest(ajaxJson);
    }
  }
});

function _authcache_easy_authcache(data) {
  var data_obj = eval("("+data+");");
//// Merge settings
  for(key1 in data_obj.js) {
        _authcache_merge_settings(data_obj.js[key1]['setting']);
  }

// includes js files
  for(key1 in data_obj.js) {
    for(key2 in data_obj.js[key1]) {
      if (key2 != 'inline' && key2 != 'setting') {
        _authcache_add_js_files(data_obj.js[key1][key2]);
      }
    }
  }
  
// insert html
  for (key in data_obj.items) {
    var context = '';
    var type = data_obj.items[key].type;
    if (type == 'text') {
      context = data_obj.items[key].output;
    }
    else {
        context = $('<'+ type +'>' + data_obj.items[key].output + '</'+ type +'>');
    }

    $(data_obj.items[key].selector).replaceWith(context);
    if (type != 'text') {
      Drupal.attachBehaviors(context);
    }
  }
}

function _authcache_merge_settings(settings) {
  for (key in settings) {
    Drupal.settings = _authcache_array_merge_recursive (settings[key], Drupal.settings);
  }
}

function _authcache_add_js_files(js_files) {
  // Make ajax sync to prevent event races
  $.ajaxSetup({async: false});
  // Store behaviours that we have before getting new js files
  var old_behaviours = new Array();
  for (key in Drupal.behaviors) {
    old_behaviours[key] = key;
  }
  
  for (key in js_files) {
    var js_exists = _authcache_in_array(key, Drupal.settings.easy_authcache_js);
    // If we have not this file load it
    if (js_exists == false) {
      $.getScript('/' + key);
      Drupal.settings.easy_authcache_js[Drupal.settings.easy_authcache_js.length] = key;
    }
  }
  // Store behaviours that we have after getting new js files
  var new_behaviours = new Array();
  for (key in Drupal.behaviors) {
    new_behaviours[key] = key;
  }

  // Get new behaviours that are differs between old and new ones
  var need_to_run = _authcache_array_diff_key(new_behaviours, old_behaviours);
  // Apply new behaviours to hole document (emulate document ready event)
  for(func in need_to_run ) {
    eval("Drupal.behaviors."+ func +"(document)");
  }
  // Return ajax to async mode
  $.ajaxSetup({async: true});
}


function _authcache_in_array (needle, haystack, argStrict) {
    // Checks if the given value exists in the array
    //
    // version: 1008.1718
    // discuss at: http://phpjs.org/functions/in_array
    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: vlado houba
    // +   input by: Billy
    // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
    // *     example 1: in_array('van', ['Kevin', 'van', 'Zonneveld']);
    // *     returns 1: true
    // *     example 2: in_array('vlado', {0: 'Kevin', vlado: 'van', 1: 'Zonneveld'});
    // *     returns 2: false
    // *     example 3: in_array(1, ['1', '2', '3']);
    // *     returns 3: true
    // *     example 3: in_array(1, ['1', '2', '3'], false);
    // *     returns 3: true
    // *     example 4: in_array(1, ['1', '2', '3'], true);
    // *     returns 4: false
    var key = '', strict = !!argStrict;

    if (strict) {
        for (key in haystack) {
            if (haystack[key] === needle) {
                return true;
            }
        }
    } else {
        for (key in haystack) {
            if (haystack[key] == needle) {
                return true;
            }
        }
    }

    return false;
}

function _authcache_array_merge () {
  // Merges elements from passed arrays into one array
  //
  // version: 1006.1915
  // discuss at: http://phpjs.org/functions/_authcache_array_merge    // +   original by: Brett Zamir (http://brett-zamir.me)
  // +   bugfixed by: Nate
  // +   input by: josh
  // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
  // *     example 1: arr1 = {"color": "red", 0: 2, 1: 4}    // *     example 1: arr2 = {0: "a", 1: "b", "color": "green", "shape": "trapezoid", 2: 4}
  // *     example 1: _authcache_array_merge(arr1, arr2)
  // *     returns 1: {"color": "green", 0: 2, 1: 4, 2: "a", 3: "b", "shape": "trapezoid", 4: 4}
  // *     example 2: arr1 = []
  // *     example 2: arr2 = {1: "data"}    // *     example 2: _authcache_array_merge(arr1, arr2)
  // *     returns 2: {0: "data"}

  var args = Array.prototype.slice.call(arguments),
  retObj = {}, k, j = 0, i = 0, retArr = true;
  for (i=0; i < args.length; i++) {
    if (!(args[i] instanceof Array)) {
      retArr=false;
      break;
    }
  }

  if (retArr) {
    retArr = [];        for (i=0; i < args.length; i++) {
      retArr = retArr.concat(args[i]);
    }
    return retArr;
  }    var ct = 0;

  for (i=0, ct=0; i < args.length; i++) {
    if (args[i] instanceof Array) {
      for (j=0; j < args[i].length; j++) {
        retObj[ct++] = args[i][j];
      }
    } else {
      for (k in args[i]) {
        if (args[i].hasOwnProperty(k)) {
          if (parseInt(k, 10)+'' === k) {
            retObj[ct++] = args[i][k];
          } else {
            retObj[k] = args[i][k];
          }
        }
      }
    }
  }
  return retObj;
}


function _authcache_array_merge_recursive (arr1, arr2){
  // Recursively merges elements from passed arrays into one array
  //
  // version: 1006.1915
  // discuss at: http://phpjs.org/functions/_authcache_array_merge_recursive    // +   original by: Subhasis Deb
  // +      input by: Brett Zamir (http://brett-zamir.me)
  // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // -    depends on: _authcache_array_merge
  // *     example 1: arr1 = {'color': {'favourite': 'read'}, 0: 5}    // *     example 1: arr2 = {0: 10, 'color': {'favorite': 'green', 0: 'blue'}}
  // *     example 1: _authcache_array_merge_recursive(arr1, arr2)
  // *     returns 1: {'color': {'favorite': {0: 'red', 1: 'green'}, 0: 'blue'}, 1: 5, 1: 10}
  var idx = '';
  if ((arr1 && (arr1 instanceof Array)) && (arr2 && (arr2 instanceof Array))) {
    for (idx in arr2) {
      arr1.push(arr2[idx]);
    }
  } else if ((arr1 && (arr1 instanceof Object)) && (arr2 && (arr2 instanceof Object))) {
    for (idx in arr2) {
      if (idx in arr1) {
        if (typeof arr1[idx] == 'object' && typeof arr2 == 'object') {
          arr1[idx] = _authcache_array_merge_recursive(arr1[idx], arr2[idx]);
        } else {
          arr1[idx] = arr2[idx];
        }
      } else {
        arr1[idx] = arr2[idx];
      }
    }
  }

  return arr1;
}

function _authcache_array_diff_key () {
    // Returns the entries of arr1 that have keys which are not present in any of the others arguments. This function is like array_diff() but works on the keys instead of the values. The associativity is preserved.
    //
    // version: 1008.1718
    // discuss at: http://phpjs.org/functions/array_diff_key    // +   original by: Ates Goral (http://magnetiq.com)
    // +    revised by: Brett Zamir (http://brett-zamir.me)
    // *     example 1: array_diff_key({red: 1, green: 2, blue: 3, white: 4}, {red: 5});
    // *     returns 1: {"green":2, "blue":3, "white":4}
    // *     example 2: array_diff_key({red: 1, green: 2, blue: 3, white: 4}, {red: 5}, {red: 5});    // *     returns 2: {"green":2, "blue":3, "white":4}
    var arr1 = arguments[0], retArr = {};
    var k1 = '', i = 1, k = '', arr = {};

    arr1keys:    for (k1 in arr1) {
        for (i = 1; i < arguments.length; i++) {
            arr = arguments[i];
            for (k in arr) {
                if (k === k1) {                    // If it reaches here, it was found in at least one array, so try next value
                    continue arr1keys;
                }
            }
            retArr[k1] = arr1[k1];        }
    }

    return retArr;
}

function _authcache_is_numeric (mixed_var) {
    // Returns true if value is a number or a numeric string
    //
    // version: 1008.1718
    // discuss at: http://phpjs.org/functions/is_numeric    // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: David
    // +   improved by: taith
    // +   bugfixed by: Tim de Koning
    // +   bugfixed by: WebDevHobo (http://webdevhobo.blogspot.com/)    // +   bugfixed by: Brett Zamir (http://brett-zamir.me)
    // *     example 1: is_numeric(186.31);
    // *     returns 1: true
    // *     example 2: is_numeric('Kevin van Zonneveld');
    // *     returns 2: false    // *     example 3: is_numeric('+186.31e2');
    // *     returns 3: true
    // *     example 4: is_numeric('');
    // *     returns 4: false
    // *     example 4: is_numeric([]);    // *     returns 4: false
    return (typeof(mixed_var) === 'number' || typeof(mixed_var) === 'string') && mixed_var !== '' && !isNaN(mixed_var);
}